' WhenTaken.VBS V1.00 (C) yoshioka.teruo@nifty.com 2006-03-19
' WhenTaken.VBS renames file to "CameraModel WhenTaken.Ext"
' Usage: Start WhenTaken.VBS files...

Option Explicit
Dim fso
Dim Shell
Dim File
Dim Path
Dim FolderName
Dim FileName
Dim BaseName
Dim ExtensionName
Dim Folder
Dim FolderItem
Dim CameraModel
Dim WhenTaken
Dim yyyy
Dim mm
Dim dd
Dim hh
Dim nn
Dim ss
Dim n

Set fso=CreateObject("Scripting.FileSystemObject")
Set Shell=CreateObject("Shell.Application")
For Each Path In WScript.Arguments
  If Not fso.FileExists(Path) Then
    WScript.Echo "File Not Found ! - "&Path
    WScript.Quit
  End If
  Set File=fso.GetFile(Path)
  Path=File.Path
  FolderName=fso.GetParentFolderName(Path)
  FileName=fso.GetFileName(Path)
  Set Folder=Shell.NameSpace(FolderName)
  Set FolderItem=Folder.Items().Item(FileName)
  Path=FolderItem.Path
  FileName=fso.GetFileName(Path)
  BaseName=fso.GetBaseName(Path)
  ExtensionName=fso.GetExtensionName(Path)
  CameraModel=FolderItem.ExtendedProperty("CameraModel")
  If CameraModel="" Then
    If InStrRev(BaseName," ") Then
      n=Mid(BaseName,InStrRev(BaseName," ")+1)
      If IsNumeric(n) Then BaseName=Left(BaseName,InStrRev(BaseName," ")-1)
    End If
    If InStrRev(BaseName," ") Then
      WhenTaken=Mid(BaseName,InStrRev(BaseName," ")+1)
      If IsDate(WhenTaken) Then BaseName=Left(BaseName,InStrRev(BaseName," ")-1)
    End If
    CameraModel=BaseName
  Else
    Call FileNameChar(CameraModel)
  End If
  WhenTaken=FolderItem.ExtendedProperty("WhenTaken")
  If IsEmpty(WhenTaken) Then
    WhenTaken=FolderItem.ModifyDate
  Else
    WhenTaken=DateAdd("n",540,WhenTaken)
  End If
  yyyy=Year(WhenTaken)
  mm=Right(100+Month(WhenTaken),2)
  dd=Right(100+Day(WhenTaken),2)
  hh=Right(100+Hour(WhenTaken),2)
  nn=Right(100+Minute(WhenTaken),2)
  ss=Right(100+Second(WhenTaken),2)
  WhenTaken=yyyy&"N"&mm&""&dd&""&hh&""&nn&""&ss&"b"
  FileName=CameraModel&" "&WhenTaken& "." & ExtensionName
  FileName=InputBox("Enter New Name",File.Name,FileName)
  n=1
  Do While FileName<>""
    Call Rename(File,FileName)
    If Err=0 Then
      FileName=""
    ElseIf Err=58 Then
      n=n+1
      FileName=CameraModel&" "&WhenTaken& " " & n & "." & ExtensionName
      FileName=InputBox(Err.Number & ":" & Err.Description & "Re-Enter New Name",File.Name,FileName)
    Else
      FileName=InputBox(Err.Number & ":" & Err.Description & "Re-Enter New Name",File.Name,FileName)
    End If
  Loop
Next
WScript.Quit

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

Sub FileNameChar(FileName)
FileName=Replace(FileName,"\","")
FileName=Replace(FileName,"/","^")
FileName=Replace(FileName,":","F")
FileName=Replace(FileName,"*","")
FileName=Replace(FileName,"?","H")
FileName=Replace(FileName,"""","h")
FileName=Replace(FileName,"<","")
FileName=Replace(FileName,">","")
FileName=Replace(FileName,"|","b")
End Sub
